---
title: AmbientLightSensor
slug: Web/API/AmbientLightSensor
tags:
  - API
  - Ambient Light Sensor API
  - AmbientLightSensor
  - Generic Sensor API
  - Interface
  - Reference
  - Sensor
  - Sensor APIs
  - Sensors
---
<p>{{APIRef("Generic Sensor API")}}{{seecompattable}}</p>

<p><span class="seoSummary">The <strong><code>AmbientLightSensor</code></strong> interface of the <a href="/docs/Web/API/Sensor_APIs">Sensor APIs</a> returns the current light level or illuminance of the ambient light around the hosting device.</span></p>

<p>To use this sensor, the user must grant permission to the <code>'ambient-light-sensor'</code> device sensor through the {{domxref('Permissions')}} API.</p>

<p>If a feature policy blocks use of a feature it is because your code is inconsistent with the policies set on your server. This is not something that would ever be shown to a user. See {{httpheader('Feature-Policy')}} for implementation instructions.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("AmbientLightSensor.AmbientLightSensor()")}}</dt>
 <dd>Creates a new <code>AmbientLightSensor</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref('AmbientLightSensor.illuminance')}}</dt>
 <dd>Returns the current light level in <a href="https://en.wikipedia.org/wiki/Lux">lux</a> of the ambient light level around the hosting device.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js notranslate">if ( 'AmbientLightSensor' in window ) {
  const sensor = new AmbientLightSensor();
  sensor.onreading = () =&gt; {
    console.log('Current light level:', sensor.illuminance);
  };
  sensor.onerror = (event) =&gt; {
    console.log(event.error.name, event.error.message);
  };
  sensor.start();
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Generic Sensor')}}</td>
   <td>{{Spec2('Generic Sensor')}}</td>
   <td>Defines sensors in general.</td>
  </tr>
  <tr>
   <td>{{SpecName('AmbientLight','#ambient-light-sensor-interface','AmbientLightSensor')}}</td>
   <td>{{Spec2('AmbientLight')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.AmbientLightSensor")}}</p>
